## createrepo 0.4.6

=== Makefile ===
PACKAGE = createrepo
VERSION = 0.4.6
SHELL = /bin/sh
top_srcdir = .
srcdir = .
prefix = /usr
exec_prefix = ${prefix}

bindir = ${exec_prefix}/bin
sbindir = ${exec_prefix}/sbin
libexecdir = ${exec_prefix}/libexec
datadir = ${prefix}/share
sysconfdir = ${prefix}/etc
sharedstatedir = ${prefix}/com
localstatedir = ${prefix}/var
libdir = ${exec_prefix}/lib
infodir = ${prefix}/info
docdir = 
includedir = ${prefix}/include
oldincludedir = /usr/include
mandir = ${prefix}/share/man

pkgdatadir = $(datadir)/$(PACKAGE)
pkglibdir = $(libdir)/$(PACKAGE)
pkgincludedir = $(includedir)/$(PACKAGE)
top_builddir = 

# all dirs
DIRS = $(DESTDIR)$(bindir) $(DESTDIR)$(sysconfdir) $(DESTDIR)$(pkgdatadir) $(DESTDIR)$(mandir)


# INSTALL scripts 
INSTALL         = install -p --verbose 
INSTALL_BIN     = $(INSTALL) -m 755 
INSTALL_DIR     = $(INSTALL) -m 755 -d 
INSTALL_DATA    = $(INSTALL) -m 644 
INSTALL_MODULES = $(INSTALL) -m 755 -D 
RM              = rm -f

SUBDIRS = bin docs

MODULES = $(srcdir)/genpkgmetadata.py \
    	  $(srcdir)/dumpMetadata.py 

.SUFFIXES: .py .pyc
.py.pyc: 
	python -c "import py_compile; py_compile.compile($*.py)"


all: $(MODULES)
	for subdir in $(SUBDIRS) ; do \
	  $(MAKE) -C $$subdir VERSION=$(VERSION) PACKAGE=$(PACKAGE) DESTDIR=$(DESTDIR); \
	done

check: 
	pychecker $(MODULES) || exit 0 

install: all installdirs
	$(INSTALL_MODULES) $(srcdir)/$(MODULES) $(DESTDIR)$(pkgdatadir)
	for subdir in $(SUBDIRS) ; do \
	  $(MAKE) -C $$subdir install VERSION=$(VERSION) PACKAGE=$(PACKAGE); \
	done

installdirs:
	for dir in $(DIRS) ; do \
      $(INSTALL_DIR) $$dir ; \
	done


uninstall:
	for module in $(MODULES) ; do \
	  $(RM) $(pkgdatadir)/$$module ; \
	done
	for subdir in $(SUBDIRS) ; do \
	  $(MAKE) -C $$subdir uninstall VERSION=$(VERSION) PACKAGE=$(PACKAGE); \
	done

clean:
	$(RM)  *.pyc *.pyo
	for subdir in $(SUBDIRS) ; do \
	  $(MAKE) -C $$subdir clean VERSION=$(VERSION) PACKAGE=$(PACKAGE); \
	done

distclean: clean
	$(RM) -r .libs
	$(RM) core
	$(RM) *~
	for subdir in $(SUBDIRS) ; do \
	  $(MAKE) -C $$subdir distclean VERSION=$(VERSION) PACKAGE=$(PACKAGE); \
	done

mostlyclean:
	$(MAKE) clean


maintainer-clean:
	$(MAKE) distclean
	$(RM) $(srcdir)/configure


dist:
	olddir=`pwd`; \
	distdir=$(PACKAGE)-$(VERSION); \
	$(RM) -r .disttmp; \
	$(INSTALL_DIR) .disttmp; \
	$(INSTALL_DIR) .disttmp/$$distdir; \
	$(MAKE) distfiles
	distdir=$(PACKAGE)-$(VERSION); \
	cd .disttmp; \
	tar -cvz > ../$$distdir.tar.gz $$distdir; \
	cd $$olddir
	$(RM) -r .disttmp

daily:
	olddir=`pwd`; \
	distdir=$(PACKAGE); \
	$(RM) -r .disttmp; \
	$(INSTALL_DIR) .disttmp; \
	$(INSTALL_DIR) .disttmp/$$distdir; \
	$(MAKE) dailyfiles
	day=`/bin/date +%Y%m%d`; \
	distdir=$(PACKAGE); \
	tarname=$$distdir-$$day ;\
	cd .disttmp; \
	perl -pi -e "s/\#DATE\#/$$day/g" $$distdir/$(PACKAGE)-daily.spec; \
	echo $$day; \
	tar -cvz > ../$$tarname.tar.gz $$distdir; \
	cd $$olddir
	$(RM) -rf .disttmp

dailyfiles:
	distdir=$(PACKAGE); \
	cp \
	$(srcdir)/*.py \
	$(srcdir)/Makefile \
	$(srcdir)/ChangeLog \
	$(srcdir)/README \
	$(srcdir)/$(PACKAGE).spec \
	$(top_srcdir)/.disttmp/$$distdir
	for subdir in $(SUBDIRS) ; do \
	  $(MAKE) -C $$subdir dailyfiles VERSION=$(VERSION) PACKAGE=$(PACKAGE); \
	done

distfiles:
	distdir=$(PACKAGE)-$(VERSION); \
	cp \
	$(srcdir)/*.py \
	$(srcdir)/Makefile \
	$(srcdir)/ChangeLog \
	$(srcdir)/README \
	$(srcdir)/$(PACKAGE).spec \
	$(top_srcdir)/.disttmp/$$distdir
	for subdir in $(SUBDIRS) ; do \
	  $(MAKE) -C $$subdir distfiles VERSION=$(VERSION) PACKAGE=$(PACKAGE); \
	done

archive: dist

.PHONY: todo
todo:
	@echo ---------------===========================================
	@grep -n TODO\\\|FIXME `find . -type f` | grep -v grep
	@echo ---------------===========================================
.PHONY: all install install-strip uninstall clean distclean mostlyclean maintainer-clean info dvi dist distfiles check installcheck installdirs daily dailyfiles

=== bin/Makefile ===
SHELL = /bin/sh
top_srcdir = ..
srcdir = ../bin
prefix = /usr
exec_prefix = ${prefix}

bindir = ${exec_prefix}/bin
sbindir = ${exec_prefix}/sbin
libexecdir = ${exec_prefix}/libexec
datadir = ${prefix}/share
sysconfdir = ${prefix}/etc
sharedstatedir = ${prefix}/com
localstatedir = ${prefix}/var
libdir = ${exec_prefix}/lib
infodir = ${prefix}/info
docdir = 
includedir = ${prefix}/include
oldincludedir = /usr/include
mandir = ${prefix}/man

pkgdatadir = $(datadir)/$(PACKAGE)
pkglibdir = $(libdir)/$(PACKAGE)
pkgincludedir = $(includedir)/$(PACKAGE)
top_builddir = ../

# all dirs
DIRS = $(DESTDIR)$(bindir) $(DESTDIR)/etc $(DESTDIR)$(pkgdatadir)


# INSTALL scripts 
INSTALL         = install -p --verbose 
INSTALL_BIN     = $(INSTALL) -m 755 
INSTALL_DIR     = $(INSTALL) -m 755 -d 
INSTALL_DATA    = $(INSTALL) -m 644 
INSTALL_MODULES = $(INSTALL) -m 755 -D 
RM 		= rm -f


all: $(srcdir)/$(PACKAGE)


install: all installdirs
	$(INSTALL_BIN) $(srcdir)/$(PACKAGE) $(DESTDIR)$(bindir)/$(PACKAGE)


uninstall:
	$(RM) $(bindir)/$(PACKAGE)



clean:


distclean:
	$(RM) -rf .libs
	$(RM) -f core
	$(RM) -f *~


mostlyclean:
	$(MAKE) clean


maintainer-clean:
	$(MAKE) distclean


distfiles:
	distdir=$(PACKAGE)-$(VERSION); \
	mkdir $(top_srcdir)/.disttmp/$$distdir/bin;\
	cp \
	$(srcdir)/$(PACKAGE) \
	$(srcdir)/Makefile \
	$(top_srcdir)/.disttmp/$$distdir/bin

dailyfiles:
	distdir=$(PACKAGE); \
	mkdir $(top_srcdir)/.disttmp/$$distdir/bin;\
	cp \
	$(srcdir)/$(PACKAGE) \
	$(srcdir)/Makefile \
	$(top_srcdir)/.disttmp/$$distdir/bin

installdirs:
	$(MAKE) -C $(top_srcdir) installdirs


.PHONY: all install install-strip uninstall clean distclean mostlyclean maintainer-clean info dvi dist distfiles check installcheck installdirs dailyfiles

## createrepo 0.4.10

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 PACKAGE = createrepo
-VERSION = 0.4.6
+VERSION = 0.4.10
 SHELL = /bin/sh
 top_srcdir = .
 srcdir = .
@@ -40,7 +40,9 @@
 SUBDIRS = bin docs
 
 MODULES = $(srcdir)/genpkgmetadata.py \
-    	  $(srcdir)/dumpMetadata.py 
+		  $(srcdir)/dumpMetadata.py \
+		  $(srcdir)/readMetadata.py \
+		  $(srcdir)/modifyrepo.py
 
 .SUFFIXES: .py .pyc
 .py.pyc: 
@@ -134,6 +136,8 @@
 	$(srcdir)/*.py \
 	$(srcdir)/Makefile \
 	$(srcdir)/ChangeLog \
+	$(srcdir)/COPYING \	
+	$(srcdir)/COPYING.lib \		
 	$(srcdir)/README \
 	$(srcdir)/$(PACKAGE).spec \
 	$(top_srcdir)/.disttmp/$$distdir
@@ -147,6 +151,8 @@
 	$(srcdir)/*.py \
 	$(srcdir)/Makefile \
 	$(srcdir)/ChangeLog \
+	$(srcdir)/COPYING \
+	$(srcdir)/COPYING.lib \
 	$(srcdir)/README \
 	$(srcdir)/$(PACKAGE).spec \
 	$(top_srcdir)/.disttmp/$$distdir

## createrepo 0.4.11

=== docs/Makefile ===
SHELL = /bin/sh
top_srcdir = ..
srcdir = ../docs
prefix = /usr
exec_prefix = ${prefix}

bindir = ${exec_prefix}/bin
sbindir = ${exec_prefix}/sbin
libexecdir = ${exec_prefix}/libexec
datadir = ${prefix}/share
sysconfdir = ${prefix}/etc
sharedstatedir = ${prefix}/com
localstatedir = ${prefix}/var
libdir = ${exec_prefix}/lib
infodir = ${prefix}/info
docdir = 
includedir = ${prefix}/include
oldincludedir = /usr/include
mandir = ${datadir}/man

pkgdatadir = $(datadir)/$(PACKAGE)
pkglibdir = $(libdir)/$(PACKAGE)
pkgincludedir = $(includedir)/$(PACKAGE)
top_builddir = ../

# all dirs
DIRS = $(DESTDIR)$(bindir) $(DESTDIR)/etc $(DESTDIR)$(pkgdatadir) $(DESTDIR)$(mandir)


# INSTALL scripts 
INSTALL         = install -p --verbose 
INSTALL_BIN     = $(INSTALL) -m 755 
INSTALL_DIR     = $(INSTALL) -m 755 -d 
INSTALL_DATA    = $(INSTALL) -m 644 
INSTALL_MODULES = $(INSTALL) -m 755 -D 
RM 		= rm -f


all: 
	echo "nothing to do"

install: all installdirs
	mkdir -p $(DESTDIR)$(mandir)/man8
	$(INSTALL_DATA) createrepo.8 $(DESTDIR)$(mandir)/man8/createrepo.8


uninstall:
	$(RM) $(bindir)/$(PACKAGE)



clean:


distclean:
	$(RM) -rf .libs
	$(RM) -f core
	$(RM) -f *~


mostlyclean:
	$(MAKE) clean


maintainer-clean:
	$(MAKE) distclean


distfiles:
	distdir=$(PACKAGE)-$(VERSION); \
	mkdir $(top_srcdir)/.disttmp/$$distdir/docs;\
	cp \
	$(srcdir)/createrepo.8 \
	$(srcdir)/Makefile \
	$(top_srcdir)/.disttmp/$$distdir/docs

dailyfiles:
	distdir=$(PACKAGE); \
	mkdir $(top_srcdir)/.disttmp/$$distdir/docs;\
	cp \
	$(srcdir)/createrepo.8 \
	$(srcdir)/Makefile \
	$(top_srcdir)/.disttmp/$$distdir/docs

installdirs:
	$(MAKE) -C $(top_srcdir) installdirs


.PHONY: all install install-strip uninstall clean distclean mostlyclean maintainer-clean info dvi dist distfiles check installcheck installdirs dailyfiles

## createrepo 0.9.8

=== debian/changelog ===
createrepo (0.9.8) unstable; urgency=low

  * update to 0.9.8

 -- Gui Chen <gui.chen@intel.com>  Wed, 1 Aug 2012 09:28:48 +0100

createrepo (0.4.11-1) unstable; urgency=low

  * New upstream release.
  * Bump Standards-Version to 3.7.3.
  * Move homepage to the new dpkg field.

 -- Adam Cécile (Le_Vert) <gandalf@le-vert.net>  Mon, 17 Dec 2007 09:28:48 +0100

createrepo (0.4.10-1) unstable; urgency=low

  * New upstream release.
  * Update debian/copyright.
  * Add runtime dependency on python-sqlitecachec.

 -- Adam Cécile (Le_Vert) <gandalf@le-vert.net>  Mon, 27 Aug 2007 09:08:16 +0200

createrepo (0.4.6-3) unstable; urgency=low

  * debian/control: Drop XB-Python-Version. 

 -- Adam Cécile (Le_Vert) <gandalf@le-vert.net>  Sun, 19 Nov 2006 03:27:50 +0100

createrepo (0.4.6-2) unstable; urgency=low

  * Update packaging to fit the last python policy draft. 

 -- Adam Cécile (Le_Vert) <gandalf@le-vert.net>  Fri, 10 Nov 2006 02:05:27 +0100

createrepo (0.4.6-1) unstable; urgency=low

  * Initial release (Closes: #386953).

 -- Adam Cécile (Le_Vert) <gandalf@le-vert.net>  Mon, 11 Sep 2006 10:14:17 +0200

=== debian/control ===
Source: createrepo
Section: admin
Priority: optional
Maintainer: Adam Cécile (Le_Vert) <gandalf@le-vert.net>
Build-Depends: debhelper (>= 5.0.37.2)
Build-Depends-Indep: python-all-dev (>= 2.3.5-11), python-support (>= 0.5.3)
Standards-Version: 3.7.3
Homepage: http://linux.duke.edu/projects/metadata/

Package: createrepo
Architecture: all
Depends: ${python:Depends}, python-rpm, rpm (>= 4.1.1), python-libxml2, python-sqlitecachec, deltarpm, yum
Description: generates the metadata necessary for a RPM package repository
 This tool will generates all XML metadata required by a RPM (Redhat Package
 Manager) package repository.
 .
 This repository format is supported by apt, red-carpet(zen), smart, up2date, 
 Yast and yum.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

build:

clean:
	dh_testdir
	dh_testroot
	$(MAKE) clean
	dh_clean 

install:
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs
	$(MAKE) install DESTDIR=$(CURDIR)/debian/createrepo sysconfdir=/etc
	rm -rf $(CURDIR)/debian/createrepo/etc

binary-indep: install
	dh_testdir -i
	dh_testroot -i
	dh_installchangelogs -i ChangeLog
	dh_installdocs -i
	dh_pysupport -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-arch: build install

binary: binary-indep

.PHONY: build clean binary-indep binary-arch binary install

## createrepo 0.9.9

=== debian/changelog ===
createrepo (0.9.9-1) unstable; urgency=low

  * New upstream release. (Closes: #463571)
    - createrepo --help now mentions --split option. (Closes: #682151)
    - No longer use deprecated md5 and sha modules. (LP: #530015)
  * New maintainer. (Closes: #673958) Thanks to Adam for his work.
  * debian/patches/01_fix-man-page-options.patch: Escape dashes in
    command-line options in man pages.
  * Cherry-pick fixes from upstream git:
    - debian/patches/02_drop-unused-imports.patch: Fix incorrect call of
      function imported from createrepo.utils.
    - debian/patches/03_fix-getting-YumAvailablePackage-local-path.patch: Fix
      getting path from repository packages.
    - debian/patches/04_fix-writing-additional-metadata.patch: Fix writing
      metadata when merging repositories.
    - debian/patches/05_fix-handling-remote-packages.patch: Fix handling
      remote packages when writing repository metadata.
  * debian/source/format: Update source format to 3.0 (quilt).
  * Bump debhelper compatibility level to 9.
  * Update packaging to current Python Policy recommendations:
    - debian/rules: Switch to using dh --with python2.
    - Add Build-Depends on python-all (>= 2.6.6-3~) for switch to building
      with dh_python2.
    - Drop Build-Depends on python-all-dev, package is not building Python
      extensions.
    - Drop Build-Depends on deprecated python-support, now using dh_python2.
    - Add X-Python-Version control field.
    - Drop obsolete debian/pyversions.
  * Install bash completion support:
    - Add Build-Depends on bash-completion.
    - Install createrepo.bash using dh_bash-completion.
  * debian/rules: Install the createrepo python module for all supported
    python versions.
  * debian/control:
    - Add Depends on ${misc:Depends}, deltarpm, python-deltarpm, and
      yum (>= 3.2.29).
    - Update package description.
    - Update Homepage control field to correct upstream URL. (Closes: #682149)
    - Set Priority to extra because Depends includes other extra packages.
    - Add Vcs-Git and Vcs-Browser fields.
    - Bump Standards-Version to 3.9.4. No further changes needed.
  * debian/copyright: Convert to machine-readable format 1.0.
  * debian/watch: Update to correct upstream URL.

 -- Mike Miller <mtmiller@ieee.org>  Mon, 19 Aug 2013 01:39:04 -0400

createrepo (0.4.11-1.1) unstable; urgency=low

  * Non maintainer upload.

  [ Scott Kitterman ]
  * In genpkgmetadata.py/SplitMetaDataGenerator, add try/except around use of
    urlparse.uses_fragment to avoid crash when running with a python version
    that does not have uses_fragment (2.7.3) (Closes: #682150)

 -- Matthias Klose <doko@debian.org>  Wed, 22 Aug 2012 19:01:30 +0200

=== debian/control ===
Source: createrepo
Section: admin
Priority: extra
Maintainer: Mike Miller <mtmiller@ieee.org>
Build-Depends: debhelper (>= 9)
Build-Depends-Indep: python-all (>= 2.6.6-3~), bash-completion
Standards-Version: 3.9.4
X-Python-Version: >= 2.4
Homepage: http://createrepo.baseurl.org/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/mtmiller-guest/createrepo.git
Vcs-Git: git://anonscm.debian.org/users/mtmiller-guest/createrepo.git

Package: createrepo
Architecture: all
Depends: ${misc:Depends},
 ${python:Depends},
 deltarpm,
 python-deltarpm,
 python-libxml2,
 python-rpm,
 python-sqlitecachec,
 rpm (>= 4.1.1),
 yum (>= 3.2.29)
Description: tool to generate the metadata for a yum repository
 The createrepo tool generates the repodata directory and XML metadata that
 makes up a repository of RPM packages. This repository format is supported
 by apt-rpm, red-carpet(zen), smartpm, up2date, yast, and yum.
 .
 This package is similar to the apt-ftparchive or reprepro commands, but for
 working with RPM repositories.

=== debian/rules ===
#!/usr/bin/make -f

SOURCE := $(shell dpkg-parsechangelog | sed -ne 's,^Source: *\(.*\)$$,\1,p')
PYTHON2 := $(shell pyversions -vr)

%:
	dh $@ --with python2

override_dh_auto_install:
	dh_auto_install -- SUBDIRS="bin docs"
	set -e && for py in $(PYTHON2); do \
		dh_auto_install -- -C createrepo \
			PKGDIR="/usr/lib/python$$py/dist-packages/$(SOURCE)"; \
	done
	dh_bash-completion
	rm -rf debian/$(SOURCE)/usr/etc

## createrepo 0.10.3

=== Makefile ===
PKGNAME = createrepo
ALIASES = mergerepo modifyrepo genpkgmetadata.py mergerepo.py modifyrepo.py
VERSION=$(shell awk '/Version:/ { print $$2 }' ${PKGNAME}.spec)
RELEASE=$(shell awk '/Release:/ { print $$2 }' ${PKGNAME}.spec)
CVSTAG=createrepo-$(subst .,_,$(VERSION)-$(RELEASE))
PYTHON=python
SUBDIRS = $(PKGNAME) bin docs
PYFILES = $(wildcard *.py)


SHELL = /bin/sh
top_srcdir = .
srcdir = .
prefix = /usr
exec_prefix = ${prefix}

bindir = ${exec_prefix}/bin
sbindir = ${exec_prefix}/sbin
libexecdir = ${exec_prefix}/libexec
datadir = ${prefix}/share
sysconfdir = ${prefix}/etc
sharedstatedir = ${prefix}/com
localstatedir = ${prefix}/var
libdir = ${exec_prefix}/lib
infodir = ${prefix}/info
docdir = 
includedir = ${prefix}/include
oldincludedir = /usr/include
mandir = ${prefix}/share/man
compdir = $(shell pkg-config --variable=completionsdir bash-completion)
compdir := $(or $(compdir), "/etc/bash_completion.d")

pkgdatadir = $(datadir)/$(PKGNAME)
pkglibdir = $(libdir)/$(PKGNAME)
pkgincludedir = $(includedir)/$(PKGNAME)
top_builddir = 

# all dirs
DIRS = $(DESTDIR)$(bindir) $(DESTDIR)$(compdir) \
	$(DESTDIR)$(pkgdatadir) $(DESTDIR)$(mandir)


# INSTALL scripts 
INSTALL         = install -p --verbose 
INSTALL_BIN     = $(INSTALL) -m 755 
INSTALL_DIR     = $(INSTALL) -m 755 -d 
INSTALL_DATA    = $(INSTALL) -m 644 
INSTALL_MODULES = $(INSTALL) -m 755 -D 
RM              = rm -f

MODULES = $(srcdir)/genpkgmetadata.py \
	$(srcdir)/modifyrepo.py \
	$(srcdir)/mergerepo.py	\
	$(srcdir)/worker.py

.SUFFIXES: .py .pyc
.py.pyc: 
	python -c "import py_compile; py_compile.compile($*.py)"


all: $(MODULES)
	for subdir in $(SUBDIRS) ; do \
	  $(MAKE) -C $$subdir VERSION=$(VERSION) PKGNAME=$(PKGNAME) DESTDIR=$(DESTDIR); \
	done

check: 
	pychecker $(MODULES) || exit 0 

install: all installdirs
	$(INSTALL_MODULES) $(srcdir)/$(MODULES) $(DESTDIR)$(pkgdatadir)
	$(INSTALL_DATA) $(PKGNAME).bash $(DESTDIR)$(compdir)/$(PKGNAME)
	(cd $(DESTDIR)$(compdir); for n in $(ALIASES); do ln -s $(PKGNAME) $$n; done)
	for subdir in $(SUBDIRS) ; do \
	  $(MAKE) -C $$subdir install VERSION=$(VERSION) PKGNAME=$(PKGNAME); \
	done

installdirs:
	for dir in $(DIRS) ; do \
      $(INSTALL_DIR) $$dir ; \
	done


uninstall:
	for module in $(MODULES) ; do \
	  $(RM) $(pkgdatadir)/$$module ; \
	done
	for subdir in $(SUBDIRS) ; do \
	  $(MAKE) -C $$subdir uninstall VERSION=$(VERSION) PKGNAME=$(PKGNAME); \
	done

clean:
	$(RM)  *.pyc *.pyo
	for subdir in $(SUBDIRS) ; do \
	  $(MAKE) -C $$subdir clean VERSION=$(VERSION) PKGNAME=$(PKGNAME); \
	done

distclean: clean
	$(RM) -r .libs
	$(RM) core
	$(RM) *~
	for subdir in $(SUBDIRS) ; do \
	  $(MAKE) -C $$subdir distclean VERSION=$(VERSION) PKGNAME=$(PKGNAME); \
	done

pylint:
	@pylint --rcfile=test/createrepo-pylintrc *.py createrepo

pylint-short:
	@pylint -r n --rcfile=test/createrepo-pylintrc *.py createrepo

mostlyclean:
	$(MAKE) clean


maintainer-clean:
	$(MAKE) distclean
	$(RM) $(srcdir)/configure

changelog:
	git log --pretty --numstat --summary | git2cl  > ChangeLog

dist:
	olddir=`pwd`; \
	distdir=$(PKGNAME)-$(VERSION); \
	$(RM) -r .disttmp; \
	$(INSTALL_DIR) .disttmp; \
	$(INSTALL_DIR) .disttmp/$$distdir; \
	$(MAKE) distfiles
	distdir=$(PKGNAME)-$(VERSION); \
	cd .disttmp; \
	tar -cvz > ../$$distdir.tar.gz $$distdir; \
	cd $$olddir
	$(RM) -r .disttmp

daily:
	olddir=`pwd`; \
	distdir=$(PKGNAME); \
	$(RM) -r .disttmp; \
	$(INSTALL_DIR) .disttmp; \
	$(INSTALL_DIR) .disttmp/$$distdir; \
	$(MAKE) dailyfiles
	day=`/bin/date +%Y%m%d`; \
	distdir=$(PKGNAME); \
	tarname=$$distdir-$$day ;\
	cd .disttmp; \
	perl -pi -e "s/\#DATE\#/$$day/g" $$distdir/$(PKGNAME)-daily.spec; \
	echo $$day; \
	tar -cvz > ../$$tarname.tar.gz $$distdir; \
	cd $$olddir
	$(RM) -rf .disttmp

dailyfiles:
	distdir=$(PKGNAME); \
	cp \
	$(srcdir)/*.py \
	$(srcdir)/Makefile \
	$(srcdir)/ChangeLog \
	$(srcdir)/COPYING \
	$(srcdir)/COPYING.lib \
	$(srcdir)/README \
	$(srcdir)/$(PKGNAME).spec \
	$(srcdir)/$(PKGNAME).bash \
	$(top_srcdir)/.disttmp/$$distdir
	for subdir in $(SUBDIRS) ; do \
	  $(MAKE) -C $$subdir dailyfiles VERSION=$(VERSION) PKGNAME=$(PKGNAME); \
	done

distfiles:
	distdir=$(PKGNAME)-$(VERSION); \
	cp \
	$(srcdir)/*.py \
	$(srcdir)/Makefile \
	$(srcdir)/ChangeLog \
	$(srcdir)/COPYING \
	$(srcdir)/COPYING.lib \
	$(srcdir)/README \
	$(srcdir)/$(PKGNAME).spec \
	$(srcdir)/$(PKGNAME).bash \
	$(top_srcdir)/.disttmp/$$distdir
	for subdir in $(SUBDIRS) ; do \
	  $(MAKE) -C $$subdir distfiles VERSION=$(VERSION) PKGNAME=$(PKGNAME); \
	done

archive: dist

.PHONY: todo
todo:
	@echo ---------------===========================================
	@grep -n TODO\\\|FIXME `find . -type f` | grep -v grep
	@echo ---------------===========================================
.PHONY: all install install-strip uninstall clean distclean mostlyclean maintainer-clean info dvi dist distfiles check installcheck installdirs daily dailyfiles

=== bin/Makefile ===
--- 
+++ 
@@ -18,9 +18,9 @@
 oldincludedir = /usr/include
 mandir = ${prefix}/man
 
-pkgdatadir = $(datadir)/$(PACKAGE)
-pkglibdir = $(libdir)/$(PACKAGE)
-pkgincludedir = $(includedir)/$(PACKAGE)
+pkgdatadir = $(datadir)/$(PKGNAME)
+pkglibdir = $(libdir)/$(PKGNAME)
+pkgincludedir = $(includedir)/$(PKGNAME)
 top_builddir = ../
 
 # all dirs
@@ -36,15 +36,18 @@
 RM 		= rm -f
 
 
-all: $(srcdir)/$(PACKAGE)
+all:
+	echo "Nothing to do"
 
 
 install: all installdirs
-	$(INSTALL_BIN) $(srcdir)/$(PACKAGE) $(DESTDIR)$(bindir)/$(PACKAGE)
+	$(INSTALL_BIN) $(srcdir)/$(PKGNAME) $(DESTDIR)$(bindir)/$(PKGNAME)
+	$(INSTALL_BIN) $(srcdir)/modifyrepo $(DESTDIR)$(bindir)/modifyrepo
+	$(INSTALL_BIN) $(srcdir)/mergerepo $(DESTDIR)$(bindir)/mergerepo
 
 
 uninstall:
-	$(RM) $(bindir)/$(PACKAGE)
+	$(RM) $(bindir)/$(PKGNAME)
 
 
 
@@ -66,19 +69,23 @@
 
 
 distfiles:
-	distdir=$(PACKAGE)-$(VERSION); \
+	distdir=$(PKGNAME)-$(VERSION); \
 	mkdir $(top_srcdir)/.disttmp/$$distdir/bin;\
 	cp \
-	$(srcdir)/$(PACKAGE) \
+	$(srcdir)/$(PKGNAME) \
 	$(srcdir)/Makefile \
+	$(srcdir)/modifyrepo \
+	$(srcdir)/mergerepo \
 	$(top_srcdir)/.disttmp/$$distdir/bin
 
 dailyfiles:
-	distdir=$(PACKAGE); \
+	distdir=$(PKGNAME); \
 	mkdir $(top_srcdir)/.disttmp/$$distdir/bin;\
 	cp \
-	$(srcdir)/$(PACKAGE) \
+	$(srcdir)/$(PKGNAME) \
 	$(srcdir)/Makefile \
+	$(srcdir)/modifyrepo \
+	$(srcdir)/mergerepo \	
 	$(top_srcdir)/.disttmp/$$distdir/bin
 
 installdirs:

=== createrepo/Makefile ===
PYTHON=python
PACKAGE = $(shell basename `pwd`)
PYFILES = $(wildcard *.py)
PYVER := $(shell $(PYTHON) -c 'import sys; print "%.3s" %(sys.version)')
PYSYSDIR := $(shell $(PYTHON) -c 'import sys; print sys.prefix')
PYLIBDIR = $(PYSYSDIR)/lib/python$(PYVER)
PKGDIR = $(PYLIBDIR)/site-packages/$(PKGNAME)

SHELL = /bin/sh
top_srcdir = ..
srcdir = ../$(PKGNAME)
prefix = /usr
exec_prefix = ${prefix}

bindir = ${exec_prefix}/bin
sbindir = ${exec_prefix}/sbin
libexecdir = ${exec_prefix}/libexec
datadir = ${prefix}/share
sysconfdir = ${prefix}/etc
sharedstatedir = ${prefix}/com
localstatedir = ${prefix}/var
libdir = ${exec_prefix}/lib
infodir = ${prefix}/info
docdir = 
includedir = ${prefix}/include
oldincludedir = /usr/include
mandir = ${datadir}/man

pkgdatadir = $(datadir)/$(PKGNAME)
pkglibdir = $(libdir)/$(PKGNAME)
pkgincludedir = $(includedir)/$(PKGNAME)
top_builddir = ../


all: 
	echo "Nothing to do"

clean:
	rm -f *.pyc *.pyo *~

install:
	mkdir -p $(DESTDIR)/$(PKGDIR)
	for p in $(PYFILES) ; do \
		install -m 644 $$p $(DESTDIR)/$(PKGDIR)/$$p; \
	done
	$(PYTHON) -c "import compileall; compileall.compile_dir('$(DESTDIR)/$(PKGDIR)', 1, '$(PKGDIR)', 1)"

distfiles:
	distdir=$(PKGNAME)-$(VERSION); \
	mkdir $(top_srcdir)/.disttmp/$$distdir/$(PKGNAME);\
	cp \
	$(srcdir)/$(PYFILES) \
	$(srcdir)/Makefile \
	$(top_srcdir)/.disttmp/$$distdir/$(PKGNAME)

dailyfiles:
	distdir=$(PKGNAME); \
	mkdir $(top_srcdir)/.disttmp/$$distdir/$(PKGNAME);\
	cp \
	$(srcdir)/$(PYFILES) \	
	$(srcdir)/__init__.py \
	$(srcdir)/Makefile \
	$(top_srcdir)/.disttmp/$$distdir/$(PKGNAME)

=== docs/Makefile ===
--- 
+++ 
@@ -18,9 +18,9 @@
 oldincludedir = /usr/include
 mandir = ${datadir}/man
 
-pkgdatadir = $(datadir)/$(PACKAGE)
-pkglibdir = $(libdir)/$(PACKAGE)
-pkgincludedir = $(includedir)/$(PACKAGE)
+pkgdatadir = $(datadir)/$(PKGNAME)
+pkglibdir = $(libdir)/$(PKGNAME)
+pkgincludedir = $(includedir)/$(PKGNAME)
 top_builddir = ../
 
 # all dirs
@@ -41,11 +41,14 @@
 
 install: all installdirs
 	mkdir -p $(DESTDIR)$(mandir)/man8
+	mkdir -p $(DESTDIR)$(mandir)/man1
 	$(INSTALL_DATA) createrepo.8 $(DESTDIR)$(mandir)/man8/createrepo.8
+	$(INSTALL_DATA) modifyrepo.1 $(DESTDIR)$(mandir)/man1/modifyrepo.1
+	$(INSTALL_DATA) mergerepo.1 $(DESTDIR)$(mandir)/man1/mergerepo.1
 
 
 uninstall:
-	$(RM) $(bindir)/$(PACKAGE)
+	$(RM) $(bindir)/$(PKGNAME)
 
 
 
@@ -67,18 +70,22 @@
 
 
 distfiles:
-	distdir=$(PACKAGE)-$(VERSION); \
+	distdir=$(PKGNAME)-$(VERSION); \
 	mkdir $(top_srcdir)/.disttmp/$$distdir/docs;\
 	cp \
 	$(srcdir)/createrepo.8 \
+	$(srcdir)/modifyrepo.1 \
+	$(srcdir)/mergerepo.1 \
 	$(srcdir)/Makefile \
 	$(top_srcdir)/.disttmp/$$distdir/docs
 
 dailyfiles:
-	distdir=$(PACKAGE); \
+	distdir=$(PKGNAME); \
 	mkdir $(top_srcdir)/.disttmp/$$distdir/docs;\
 	cp \
 	$(srcdir)/createrepo.8 \
+	$(srcdir)/modifyrepo.1 \
+	$(srcdir)/mergerepo.1 \
 	$(srcdir)/Makefile \
 	$(top_srcdir)/.disttmp/$$distdir/docs

=== debian/changelog ===
createrepo (0.10.3-1) unstable; urgency=medium

  * New upstream release.
    - Ensure the -s/--checksum option is applied correctly. (Closes: #731147)
  * Drop patches applied upstream:
    - 01_fix-man-page-options.patch
    - 02_drop-unused-imports.patch
    - 03_fix-getting-YumAvailablePackage-local-path.patch
    - 04_fix-writing-additional-metadata.patch
    - 05_fix-handling-remote-packages.patch
  * Add Depends on python-lzma.
  * fix-version.patch: Fix version string reported by --version.
  * Update bash-completion support to install with pkg-config:
    - Add Build-Depends on pkg-config.
    - Let the buildsystem install createrepo.bash using pkg-config.
    - createrepo.maintscript: Remove obsolete bash-completion conffile.
  * Update Vcs-* control fields to new Git repository.
  * Use my @debian.org address.
  * Bump Standards-Version to 3.9.5. No changes needed.

 -- Mike Miller <mtmiller@debian.org>  Thu, 06 Feb 2014 10:07:19 -0500

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: createrepo
 Section: admin
 Priority: extra
-Maintainer: Mike Miller <mtmiller@ieee.org>
+Maintainer: Mike Miller <mtmiller@debian.org>
 Build-Depends: debhelper (>= 9)
-Build-Depends-Indep: python-all (>= 2.6.6-3~), bash-completion
-Standards-Version: 3.9.4
+Build-Depends-Indep: python-all (>= 2.6.6-3~), bash-completion, pkg-config
+Standards-Version: 3.9.5
 X-Python-Version: >= 2.4
 Homepage: http://createrepo.baseurl.org/
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/mtmiller-guest/createrepo.git
-Vcs-Git: git://anonscm.debian.org/users/mtmiller-guest/createrepo.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/mtmiller/createrepo.git
+Vcs-Git: git://anonscm.debian.org/users/mtmiller/createrepo.git
 
 Package: createrepo
 Architecture: all
@@ -17,6 +17,7 @@
  deltarpm,
  python-deltarpm,
  python-libxml2,
+ python-lzma,
  python-rpm,
  python-sqlitecachec,
  rpm (>= 4.1.1),

=== debian/rules ===
--- 
+++ 
@@ -12,5 +12,3 @@
 		dh_auto_install -- -C createrepo \
 			PKGDIR="/usr/lib/python$$py/dist-packages/$(SOURCE)"; \
 	done
-	dh_bash-completion
-	rm -rf debian/$(SOURCE)/usr/etc

=== debian/watch ===
version=3
http://createrepo.baseurl.org/download/createrepo-(.*)\.tar\.gz

## createrepo 0.10.9

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,4 @@
 PKGNAME = createrepo
-ALIASES = mergerepo modifyrepo genpkgmetadata.py mergerepo.py modifyrepo.py
 VERSION=$(shell awk '/Version:/ { print $$2 }' ${PKGNAME}.spec)
 RELEASE=$(shell awk '/Release:/ { print $$2 }' ${PKGNAME}.spec)
 CVSTAG=createrepo-$(subst .,_,$(VERSION)-$(RELEASE))
@@ -27,8 +26,6 @@
 includedir = ${prefix}/include
 oldincludedir = /usr/include
 mandir = ${prefix}/share/man
-compdir = $(shell pkg-config --variable=completionsdir bash-completion)
-compdir := $(or $(compdir), "/etc/bash_completion.d")
 
 pkgdatadir = $(datadir)/$(PKGNAME)
 pkglibdir = $(libdir)/$(PKGNAME)
@@ -36,7 +33,7 @@
 top_builddir = 
 
 # all dirs
-DIRS = $(DESTDIR)$(bindir) $(DESTDIR)$(compdir) \
+DIRS = $(DESTDIR)$(bindir) $(DESTDIR)$(sysconfdir)/bash_completion.d \
 	$(DESTDIR)$(pkgdatadir) $(DESTDIR)$(mandir)
 
 
@@ -50,8 +47,7 @@
 
 MODULES = $(srcdir)/genpkgmetadata.py \
 	$(srcdir)/modifyrepo.py \
-	$(srcdir)/mergerepo.py	\
-	$(srcdir)/worker.py
+	$(srcdir)/mergerepo.py	
 
 .SUFFIXES: .py .pyc
 .py.pyc: 
@@ -68,8 +64,7 @@
 
 install: all installdirs
 	$(INSTALL_MODULES) $(srcdir)/$(MODULES) $(DESTDIR)$(pkgdatadir)
-	$(INSTALL_DATA) $(PKGNAME).bash $(DESTDIR)$(compdir)/$(PKGNAME)
-	(cd $(DESTDIR)$(compdir); for n in $(ALIASES); do ln -s $(PKGNAME) $$n; done)
+	$(INSTALL_DATA) $(PKGNAME).bash $(DESTDIR)$(sysconfdir)/bash_completion.d
 	for subdir in $(SUBDIRS) ; do \
 	  $(MAKE) -C $$subdir install VERSION=$(VERSION) PKGNAME=$(PKGNAME); \
 	done

=== debian/changelog ===
createrepo (0.10.9) unstable; urgency=low

  * Make modifyrepo insert size and open-size tag

 -- Yan Meng <yan11.meng@samsung.com>  Wed, 17 Jun 2020 09:28:48 +0100

createrepo (0.10.8) unstable; urgency=low

  * update to 0.10.8

 -- Biao Wang <biao716.wang@samsung.com>  Wed, 20 Nov 2019 09:28:48 +0100

=== debian/control ===
Source: createrepo
Section: admin
Priority: optional
Maintainer: Adam Cécile (Le_Vert) <gandalf@le-vert.net>
Build-Depends: debhelper (>= 5.0.37.2)
Build-Depends-Indep: python-all-dev (>= 2.3.5-11), python-support (>= 0.5.3)
Standards-Version: 3.7.3
Homepage: http://linux.duke.edu/projects/metadata/

Package: createrepo
Architecture: all
Depends: ${python:Depends}, python-rpm, rpm (>= 4.1.1), python-lxml, python-libxml2, python-sqlitecachec, deltarpm, yum
Description: generates the metadata necessary for a RPM package repository
 This tool will generates all XML metadata required by a RPM (Redhat Package
 Manager) package repository.
 .
 This repository format is supported by apt, red-carpet(zen), smart, up2date, 
 Yast and yum.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

build:

clean:
	dh_testdir
	dh_testroot
	$(MAKE) clean
	dh_clean 

install:
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs
	$(MAKE) install DESTDIR=$(CURDIR)/debian/createrepo sysconfdir=/etc
	rm -rf $(CURDIR)/debian/createrepo/etc

binary-indep: install
	dh_testdir -i
	dh_testroot -i
	dh_installchangelogs -i ChangeLog
	dh_installdocs -i
	dh_python2 -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-arch: build install

binary: binary-indep

.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
version=3
http://linux.duke.edu/projects/metadata/generate/createrepo-(.*).tar.gz

## createrepo c-0.16.0

=== doc/python/CMakeLists.txt ===
ADD_CUSTOM_TARGET (doc-python
    PYTHONPATH=${CMAKE_BINARY_DIR}/src/python sphinx-build -E -b html
                  ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}/html
                  COMMENT "Building Python API documentation with Sphinx")

=== src/python/CMakeLists.txt ===
MACRO(PYTHON_UNSET)
    unset(PYTHON_LIBRARY)
    unset(PYTHON_INCLUDE_DIR)
    unset(PYTHON_EXECUTABLE)
    unset(PYTHON_LIBRARY CACHE)
    unset(PYTHON_INCLUDE_DIR CACHE)
    unset(PYTHON_EXECUTABLE CACHE)
ENDMACRO(PYTHON_UNSET)

if (NOT SKBUILD)
    if (${PYTHON_DESIRED} STREQUAL "2")
        PYTHON_UNSET()
        FIND_PACKAGE(PythonLibs 2 EXACT)
        FIND_PACKAGE(PythonInterp 2 EXACT REQUIRED)
    elseif (${PYTHON_DESIRED} STREQUAL "3")
        PYTHON_UNSET()
        SET(Python_ADDITIONAL_VERSIONS 3.0 CACHE INTERNAL "")
        FIND_PACKAGE(PythonLibs 3 EXACT)
        FIND_PACKAGE(PythonInterp 3 EXACT REQUIRED)
    elseif (EXISTS ${PYTHON_DESIRED})
        PYTHON_UNSET()
        SET(PYTHON_EXECUTABLE ${PYTHON_DESIRED} CACHE INTERNAL "")
        FIND_PACKAGE(PythonInterp REQUIRED)
        FIND_PACKAGE(PythonLibs)
    else ()
        MESSAGE(FATAL_ERROR "Invalid PYTHON_DESIRED value: " ${PYTHON_DESIRED})
    endif ()
endif (NOT SKBUILD)

EXECUTE_PROCESS(COMMAND ${PYTHON_EXECUTABLE} -c "from sys import stdout; from distutils import sysconfig; stdout.write(sysconfig.get_python_lib(True))" OUTPUT_VARIABLE PYTHON_INSTALL_DIR)
INCLUDE_DIRECTORIES (${PYTHON_INCLUDE_PATH})

MESSAGE(STATUS "Python install dir is ${PYTHON_INSTALL_DIR}")

set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-strict-aliasing")
set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fno-strict-aliasing")
set (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -fno-strict-aliasing")

SET (createrepo_cmodule_SRCS
     checksum-py.c
     compression_wrapper-py.c
     contentstat-py.c
     createrepo_cmodule.c
     exception-py.c
     load_metadata-py.c
     locate_metadata-py.c
     misc-py.c
     package-py.c
     parsepkg-py.c
     repomd-py.c
     repomdrecord-py.c
     sqlite-py.c
     typeconversion.c
     updatecollection-py.c
     updatecollectionmodule-py.c
     updatecollectionpackage-py.c
     updateinfo-py.c
     updaterecord-py.c
     updatereference-py.c
     xml_dump-py.c
     xml_file-py.c
     xml_parser-py.c
    )

ADD_LIBRARY(_createrepo_c SHARED ${createrepo_cmodule_SRCS})
SET_TARGET_PROPERTIES(_createrepo_c PROPERTIES PREFIX "")
SET_TARGET_PROPERTIES(_createrepo_c PROPERTIES LIBRARY_OUTPUT_DIRECTORY "./createrepo_c")
TARGET_LINK_LIBRARIES(_createrepo_c libcreaterepo_c)
TARGET_LINK_LIBRARIES(_createrepo_c
                        ${CURL_LIBRARY}
                     )

IF (SKBUILD)
    find_package(PythonExtensions REQUIRED)
    python_extension_module(_createrepo_c)
ELSE ()
    TARGET_LINK_LIBRARIES(_createrepo_c ${PYTHON_LIBRARY})
ENDIF ()

IF (NOT SKBUILD)
    FILE(COPY createrepo_c/__init__.py DESTINATION createrepo_c)
ENDIF()

IF (SKBUILD)
    INSTALL(FILES createrepo_c/__init__.py DESTINATION src/python/createrepo_c)
    INSTALL(TARGETS _createrepo_c LIBRARY DESTINATION src/python/createrepo_c)
ELSE ()
    INSTALL(FILES createrepo_c/__init__.py DESTINATION ${PYTHON_INSTALL_DIR}/createrepo_c)
    INSTALL(TARGETS _createrepo_c LIBRARY DESTINATION ${PYTHON_INSTALL_DIR}/createrepo_c)

    # Version has to be passed as last argument.
    INSTALL(CODE "EXECUTE_PROCESS(COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/utils/setup_for_python_metadata.py install_egg_info --install-dir \$ENV{DESTDIR}/${PYTHON_INSTALL_DIR} ${VERSION})")
ENDIF ()

## createrepo c-0.21.1

=== CMakeLists.txt ===
PROJECT (createrepo_c C)
CMAKE_MINIMUM_REQUIRED (VERSION 2.8.12)

include(GNUInstallDirs)

set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS} -ggdb -g -Wall -Wextra -Og")
IF(NOT CMAKE_BUILD_TYPE)
    SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

IF(CMAKE_BUILD_TYPE AND CMAKE_BUILD_TYPE STREQUAL "DEBUG")
    MESSAGE("Build type is set do DEBUG! (Used flags: \"${CMAKE_C_FLAGS_DEBUG}\")")
ENDIF()


option(BUILD_LIBCREATEREPO_C_SHARED "Build libcreaterepo_c as a shared library" ON)
if(NOT BUILD_LIBCREATEREPO_C_SHARED)
  set(CMAKE_POSITION_INDEPENDENT_CODE 1)
endif()

option(CREATEREPO_C_INSTALL_DEVELOPMENT "Install createrepo_c development files." ON)
option(CREATEREPO_C_INSTALL_MANPAGES "Install createrepo_c man-pages." ON)

# Add path with own cmake modules

INCLUDE_DIRECTORIES (${CMAKE_SOURCE_DIR})
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

SET(G_LOG_DOMAIN "C_CREATEREPOLIB")

# Find necessary libraries
find_package(PkgConfig)
find_package(BZip2 REQUIRED)
find_package(CURL REQUIRED)
find_package(LibXml2 REQUIRED)
find_package(OpenSSL REQUIRED)
find_package(ZLIB REQUIRED)

pkg_check_modules(GLIB2 REQUIRED glib-2.0)
pkg_check_modules(GIO REQUIRED gio-2.0)
pkg_check_modules(GTHREAD2 REQUIRED gthread-2.0)
pkg_check_modules(LZMA REQUIRED liblzma)
pkg_check_modules(SQLITE3 REQUIRED sqlite3)
pkg_check_modules(RPM REQUIRED rpm)

pkg_check_modules(LIBMAGIC libmagic)
# the pkg-config was only added in F33
IF (NOT LIBMAGIC_FOUND)
    find_path(LIBMAGIC_INCLUDE_DIRS NAMES magic.h PATHS ${CMAKE_INCLUDE_PATH})
    find_library(LIBMAGIC_LIBRARIES NAMES magic PATHS ${CMAKE_LIBRARY_PATH})
ENDIF()

# Add include dirs

include_directories(${BZIP2_INCLUDE_DIRS})
include_directories(${CURL_INCLUDE_DIRS})
include_directories(${GLIB2_INCLUDE_DIRS})
include_directories(${GIO_INCLUDE_DIRS})
include_directories(${LIBXML2_INCLUDE_DIR})
include_directories(${OPENSSL_INCLUDE_DIR})
include_directories(${ZLIB_INCLUDE_DIR})

# SuSE/Mageia/Mandriva legacy weak deps support
OPTION (ENABLE_LEGACY_WEAKDEPS "Enable legacy SUSE/Mageia/Mandriva weakdeps support?" ON)
IF (ENABLE_LEGACY_WEAKDEPS)
    ADD_DEFINITIONS("-DENABLE_LEGACY_WEAKDEPS=1")
ENDIF (ENABLE_LEGACY_WEAKDEPS)

# Legacy hash functions
OPTION (WITH_LEGACY_HASHES "Build with SHA-1 and MD5 support" OFF)
IF (WITH_LEGACY_HASHES)
    ADD_DEFINITIONS("-DWITH_LEGACY_HASHES=1")
ENDIF (WITH_LEGACY_HASHES)

# drpm
OPTION (ENABLE_DRPM "Enable delta RPM support?" OFF)
IF (ENABLE_DRPM)
    pkg_check_modules(DRPM REQUIRED drpm>=0.4.0)
    include_directories (${DRPM_INCLUDE_DIRS})
    ADD_DEFINITIONS("-DCR_DELTA_RPM_SUPPORT")
ENDIF (ENABLE_DRPM)

# option to enable/disable python support
OPTION (ENABLE_PYTHON "Enable python support?" ON)

OPTION (WITH_ZCHUNK "Build with zchunk support" ON)
IF (WITH_ZCHUNK)
    pkg_check_modules(ZCK REQUIRED zck)
    include_directories(${ZCK_INCLUDE_DIRS})
    SET (CMAKE_C_FLAGS          "${CMAKE_C_FLAGS} -DWITH_ZCHUNK")
    SET (CMAKE_C_FLAGS_DEBUG    "${CMAKE_C_FLAGS_DEBUG} -DWITH_ZCHUNK")
ENDIF (WITH_ZCHUNK)

OPTION (WITH_LIBMODULEMD "Build with libmodulemd support" ON)
IF (WITH_LIBMODULEMD)
    pkg_check_modules(LIBMODULEMD REQUIRED modulemd-2.0)
    include_directories(${LIBMODULEMD_INCLUDE_DIRS})
    SET (CMAKE_C_FLAGS          "${CMAKE_C_FLAGS} -DWITH_LIBMODULEMD")
    SET (CMAKE_C_FLAGS_DEBUG    "${CMAKE_C_FLAGS_DEBUG} -DWITH_LIBMODULEMD")
ENDIF (WITH_LIBMODULEMD)

# Threaded XZ Compression
# Note: This option is disabled by default, because Createrepo_c
# parallelize a lot of tasks (including compression) by default, this
# only adds extra threads on XZ library level which causes thread bloat
# and for most usecases doesn't bring any performance boost.
# On regular hardware (e.g. less-or-equal 4 cores) this option may even
# cause degradation of performance.
OPTION(ENABLE_THREADED_XZ_ENCODER "Enable threaded XZ encoder?" OFF)
IF (ENABLE_THREADED_XZ_ENCODER)
    ADD_DEFINITIONS("-DENABLE_THREADED_XZ_ENCODER=1")
ENDIF (ENABLE_THREADED_XZ_ENCODER)

# Get package version
INCLUDE (${CMAKE_SOURCE_DIR}/VERSION.cmake)
SET (VERSION "${CR_MAJOR}.${CR_MINOR}.${CR_PATCH}")
message("Package version: ${VERSION}")

# Other files

OPTION(ENABLE_BASHCOMP "Install Bash autocompletions?" ON)
IF (ENABLE_BASHCOMP)
    pkg_check_modules(BASHCOMP bash-completion)
    IF (BASHCOMP_FOUND)
        execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=completionsdir bash-completion OUTPUT_VARIABLE BASHCOMP_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
        message("Bash completion directory: ${BASHCOMP_DIR}")
        INSTALL(FILES createrepo_c.bash DESTINATION ${BASHCOMP_DIR} RENAME createrepo_c)
        INSTALL(CODE "
            execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink createrepo_c \$ENV{DESTDIR}${BASHCOMP_DIR}/mergerepo_c)
            execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink createrepo_c \$ENV{DESTDIR}${BASHCOMP_DIR}/modifyrepo_c)
            execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink createrepo_c \$ENV{DESTDIR}${BASHCOMP_DIR}/sqliterepo_c)
            ")
    ELSEIF (BASHCOMP_FOUND)
        INSTALL(FILES createrepo_c.bash DESTINATION "/etc/bash_completion.d")
        message("Bash completion directory: /etc/bash_completion.d")
    ENDIF (BASHCOMP_FOUND)
ENDIF (ENABLE_BASHCOMP)


# Gen manpage

#message("Gen manpage")
#execute_process(COMMAND bash gen_manpage.sh src/cmd_parser.c ../doc/ WORKING_DIRECTORY utils/)

# Add custom target for tests

ADD_CUSTOM_TARGET(tests)


# Subdirs

ADD_SUBDIRECTORY (src)
ADD_SUBDIRECTORY (doc)
ENABLE_TESTING()
ADD_SUBDIRECTORY (tests EXCLUDE_FROM_ALL)

=== src/CMakeLists.txt ===
SET (createrepo_c_SRCS
     checksum.c
     compression_wrapper.c
     createrepo_shared.c
     deltarpms.c
     dumper_thread.c
     error.c
     helpers.c
     load_metadata.c
     locate_metadata.c
     misc.c
     modifyrepo_shared.c
     package.c
     parsehdr.c
     parsepkg.c
     repomd.c
     sqlite.c
     threads.c
     updateinfo.c
     xml_dump.c
     xml_dump_deltapackage.c
     xml_dump_filelists.c
     xml_dump_other.c
     xml_dump_primary.c
     xml_dump_repomd.c
     xml_dump_updateinfo.c
     xml_file.c
     xml_parser.c
     xml_parser_filelists.c
     xml_parser_other.c
     xml_parser_primary.c
     xml_parser_repomd.c
     xml_parser_updateinfo.c
     xml_parser_main_metadata_together.c
     koji.c)

SET(headers
    checksum.h
    compression_wrapper.h
    constants.h
    mergerepo_c.h
    createrepo_c.h
    createrepo_shared.h
    deltarpms.h
    error.h
    helpers.h
    load_metadata.h
    locate_metadata.h
    misc.h
    modifyrepo_shared.h
    package.h
    parsehdr.h
    parsepkg.h
    repomd.h
    sqlite.h
    threads.h
    updateinfo.h
    version.h
    xml_dump.h
    xml_file.h
    koji.h
    xml_parser.h)

IF (BUILD_LIBCREATEREPO_C_SHARED)
  SET (createrepo_c_library_type SHARED)
ELSE ()
  SET (createrepo_c_library_type STATIC)
ENDIF ()
ADD_LIBRARY(libcreaterepo_c ${createrepo_c_library_type} ${createrepo_c_SRCS})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${BZIP2_LIBRARIES})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${CURL_LIBRARY})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${GLIB2_LIBRARIES})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${GIO_LIBRARIES})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${LIBMAGIC_LIBRARIES})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${LIBMODULEMD_LIBRARIES})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${LIBXML2_LIBRARIES})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${LZMA_LIBRARIES})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${OPENSSL_LIBRARIES})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${RPM_LIBRARIES})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${SQLITE3_LIBRARIES})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${ZLIB_LIBRARY})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${ZCK_LIBRARIES})
TARGET_LINK_LIBRARIES(libcreaterepo_c ${DRPM_LIBRARIES})

SET_TARGET_PROPERTIES(libcreaterepo_c PROPERTIES
                      OUTPUT_NAME "createrepo_c"
                      SOVERSION ${CR_MAJOR}
                      VERSION "${VERSION}"
                      COMPILE_DEFINITIONS "G_LOG_DOMAIN=\"${G_LOG_DOMAIN}\"")

ADD_EXECUTABLE(createrepo_c createrepo_c.c cmd_parser.c)
TARGET_LINK_LIBRARIES(createrepo_c
                        libcreaterepo_c
                        ${GLIB2_LIBRARIES}
                        ${GTHREAD2_LIBRARIES})

ADD_EXECUTABLE(mergerepo_c mergerepo_c.c)
TARGET_LINK_LIBRARIES(mergerepo_c
                        libcreaterepo_c
                        ${GLIB2_LIBRARIES}
                        ${GTHREAD2_LIBRARIES}
                        ${LIBMODULEMD_LIBRARIES})

ADD_EXECUTABLE(modifyrepo_c modifyrepo_c.c)
TARGET_LINK_LIBRARIES(modifyrepo_c
                        libcreaterepo_c
                        ${GLIB2_LIBRARIES}
                        ${GTHREAD2_LIBRARIES})

ADD_EXECUTABLE(sqliterepo_c sqliterepo_c.c)
TARGET_LINK_LIBRARIES(sqliterepo_c
                        libcreaterepo_c
                        ${GLIB2_LIBRARIES}
                        ${GTHREAD2_LIBRARIES})

CONFIGURE_FILE("createrepo_c.pc.cmake" "${CMAKE_SOURCE_DIR}/src/createrepo_c.pc" @ONLY)
CONFIGURE_FILE("version.h.in" "${CMAKE_CURRENT_SOURCE_DIR}/version.h" @ONLY)
CONFIGURE_FILE("deltarpms.h.in" "${CMAKE_CURRENT_SOURCE_DIR}/deltarpms.h" @ONLY)

IF (CREATEREPO_C_INSTALL_DEVELOPMENT OR "${createrepo_c_library_type}" STREQUAL "SHARED")
    INSTALL(
        TARGETS libcreaterepo_c
        RUNTIME DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT RuntimeLibraries
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT RuntimeLibraries
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Development
        )
ENDIF (CREATEREPO_C_INSTALL_DEVELOPMENT OR "${createrepo_c_library_type}" STREQUAL "SHARED")

IF (CREATEREPO_C_INSTALL_DEVELOPMENT)
    INSTALL(FILES ${headers} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/createrepo_c")
    INSTALL(FILES "createrepo_c.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
ENDIF (CREATEREPO_C_INSTALL_DEVELOPMENT)

IF (NOT DEFINED BIN_INSTALL_DIR)
    SET(BIN_INSTALL_DIR "bin/")
ENDIF (NOT DEFINED BIN_INSTALL_DIR)
INSTALL(
    TARGETS
        createrepo_c
        mergerepo_c
        modifyrepo_c
        sqliterepo_c
    RUNTIME DESTINATION ${BIN_INSTALL_DIR} COMPONENT Runtime
    )

IF (ENABLE_PYTHON)
    ADD_SUBDIRECTORY(python)
ENDIF (ENABLE_PYTHON)

## createrepo c-1.2.1

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -61,6 +61,23 @@
     koji.h
     xml_parser.h)
 
+# glibc needs _XOPEN_SOURCE >= 500 defined in order to expose nftw(),
+# other systems do not need this macro defined.  If necessary, set the
+# macro to 700 since that's the 7th revision which is what the Python
+# pieces will want.
+INCLUDE (CheckSymbolExists)
+CHECK_SYMBOL_EXISTS(nftw ftw.h HAVE_NFTW)
+IF (NOT HAVE_NFTW)
+    LIST(APPEND CMAKE_REQUIRED_DEFINITIONS -D_XOPEN_SOURCE=700)
+    CHECK_SYMBOL_EXISTS(nftw ftw.h HAVE_NFTW_XOPEN)
+
+    IF (HAVE_NFTW_XOPEN)
+        ADD_COMPILE_DEFINITIONS(_XOPEN_SOURCE=700)
+    ELSE ()
+        ERROR("unable to find nftw() definition")
+    ENDIF ()
+ENDIF ()
+
 IF (BUILD_LIBCREATEREPO_C_SHARED)
   SET (createrepo_c_library_type SHARED)
 ELSE ()
@@ -71,7 +88,6 @@
 TARGET_LINK_LIBRARIES(libcreaterepo_c ${CURL_LIBRARY})
 TARGET_LINK_LIBRARIES(libcreaterepo_c ${GLIB2_LIBRARIES})
 TARGET_LINK_LIBRARIES(libcreaterepo_c ${GIO_LIBRARIES})
-TARGET_LINK_LIBRARIES(libcreaterepo_c ${LIBMAGIC_LIBRARIES})
 TARGET_LINK_LIBRARIES(libcreaterepo_c ${LIBMODULEMD_LIBRARIES})
 TARGET_LINK_LIBRARIES(libcreaterepo_c ${LIBXML2_LIBRARIES})
 TARGET_LINK_LIBRARIES(libcreaterepo_c ${LZMA_LIBRARIES})
@@ -81,6 +97,7 @@
 TARGET_LINK_LIBRARIES(libcreaterepo_c ${ZLIB_LIBRARY})
 TARGET_LINK_LIBRARIES(libcreaterepo_c ${ZCK_LIBRARIES})
 TARGET_LINK_LIBRARIES(libcreaterepo_c ${DRPM_LIBRARIES})
+TARGET_LINK_LIBRARIES(libcreaterepo_c ${ZSTD_LIBRARIES})
 
 SET_TARGET_PROPERTIES(libcreaterepo_c PROPERTIES
                       OUTPUT_NAME "createrepo_c"
